import commander
import pygame
import time
import sys


def keyboard_controller(angle, yaw_rate):
    """
    Args:
        angle (float): rotation in degrees
        yaw_rate (int): rotation around the z-axis. Rotate the drone's heading to left or right. Range is (-100)-(+100).
    """
    height = 0.1
    roll_set = 0
    pitch_set = 0
    yaw_set = 0

    pygame.init()
    screen = pygame.display.set_mode((640, 480))
    pygame.display.set_caption("PyGame Keyboard Test")
    pygame.mouse.set_visible(0)
    running = True

    while running:
        events = pygame.event.get()

        for event in events:
            if event.type == pygame.QUIT:
                # commander.land()
                running = False
                pygame.quit()
                # sys.exit()

            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:  # exit
                    # commander.land()
                    running = False
                    pygame.quit()
                    # sys.exit()

                elif event.key == pygame.K_UP:  # go forward
                    pitch_set = -angle

                elif event.key == pygame.K_DOWN:  # go backward
                    pitch_set = angle

                elif event.key == pygame.K_LEFT:  # go left
                    roll_set = -angle

                elif event.key == pygame.K_RIGHT:  # go right
                    roll_set = angle

                elif event.key == pygame.K_d:  # turn right
                    yaw_set = yaw_rate

                elif event.key == pygame.K_a:  # turn left
                    yaw_set = -yaw_rate

                elif event.key == pygame.K_w:  # go up
                    height = height + 0.1
                    if height > 2.0:
                        height = 2.0
                    height = round(height, 1)

                elif event.key == pygame.K_s:  # go down
                    height = height - 0.1
                    if height < 0.0:
                        height = 0.0
                    height = round(height, 1)

            elif event.type == pygame.KEYUP:
                if event.key == pygame.K_ESCAPE:
                    pass

                elif event.key == pygame.K_UP:
                    pitch_set = 0

                elif event.key == pygame.K_DOWN:
                    pitch_set = 0

                elif event.key == pygame.K_LEFT:
                    roll_set = 0

                elif event.key == pygame.K_RIGHT:
                    roll_set = 0

                elif event.key == pygame.K_d:
                    yaw_set = 0

                elif event.key == pygame.K_a:
                    yaw_set = 0

                elif event.key == pygame.K_w:
                    pass

                elif event.key == pygame.K_s:
                    pass

        # send the command
        commander.fly_altitude_hold_mode(height, roll_set, pitch_set, yaw_set)
        time.sleep(0.05)
    return
