# include python libraries and packages
import commander
import communicator
import sys
import keyboard
import time


def takeoff_land(height, time_duration):
    """
    An example function for takeout and land using position hold mode

    Args:
        height (float): flying height
        time_duration (float): fling time
    """
    commander.takeoff_and_hover(height, time_duration)
    commander.land()
    # sys.exit()


def move_square(height, velocity, time_duration):
    """
    An example function for fly drone in a square path

    Args:
        height (float):
        velocity (float):
    """
    commander.takeoff(height)
    commander.go_forward(velocity, time_duration)
    commander.go_left(velocity, time_duration)
    commander.go_backward(velocity, time_duration)
    commander.go_right(velocity, time_duration)
    commander.land()
    # sys.exit()


def move_by_keyboard(angle, yaw_rate):
    """
    An example function for fly drone using the keyboard

    Args:
        angle (int):
        yaw_rate (int):
    """
    keyboard.keyboard_controller(angle, yaw_rate)
    commander.land()
    # sys.exit()

def ping_pong(bounces = 5):
    commander.takeoff(1.0)
    time.sleep(5)
    for i in range(bounces):
        commander.set_height(0.4)
        time.sleep(2)
        commander.set_height(1.0)
        time.sleep(2)
    commander.land()

def main():
    
    #-------- LEDs will flash to indicate packet received (Wi-Fi connection established successfully)----------------
    #commander.verification_LED()  
    
    #-------- Bounce the drone up and down 5 times --------------------
    #ping_pong(5)          

    # ------- Take off and fly up to 0.8m, wait for 5 seconds in position hold mode, and land ----------------------
    #takeoff_land(0.8, 5)

    # ------- Move the drone in a square path ---------------------------------------
    #move_square(0.8, 0.4, 3)


    # ------- Control drone using the keyboard --------------------------------------
    #move_by_keyboard(5, 8)  # set tit angle as 5 and rotation rate as 8 while moving


    sys.exit()


if __name__ == "__main__":
    main()
